#include <bits/stdc++.h>

using namespace std;

int n,m;
int niz[100005],pom[100005];
vector<int> kecevi[32];
int log(int a)
{
    int br=0;
    while(a/2>0) br++;
    return br;
}
void imakec(int a)
{
    int j=1;
    for(int i=1;i<niz[a];i<<1)
    {
        if((i&niz[a])==1) kecevi[j].push_back(a);
        j++;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    int br1=0,br0=0;
    bool jn=true;
    for(int i=0;i<n;i++)
    {
        cin>>niz[i];
        pom[i]=niz[i];
        imakec(i);
        if(niz[i]==1) br1++;
        else if(niz[i]==0) br0++;
        else jn=false;
    }
    cin>>m;
    if(jn==true)
    {
        while(m--)
        {
            int t,k,x;
            cin>>t;
            if(t==0)
            {
                cin>>k;
                if(k>br1) cout<<0<<endl;
                else cout<<1<<endl;
            }
            else
            {
                cin>>k>>x;
                k--;
                if(niz[k]!=x)
                {
                    if(niz[k]==1) {br1--;br0++;}
                    else {br0--;br1++;}
                }
                niz[k]=x;
            }
        }
    }
    else
    {
        while(m--)
        {
            int t,k,x;
            cin>>t;
            if(t==0)
            {
                cin>>k;
                k--;
            }
            else
            {
                cin>>k>>x;
                k--;
            niz[k]=x;
            }
        }
    }
    return 0;
    //tuzan smajli
}